VTK: vtkWidgetEventTranslator Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkWidgetEventTranslator Class Reference

map VTK events into widget events More...

`#include <vtkWidgetEventTranslator.h>`

Inheritance diagram for vtkWidgetEventTranslator:
[legend]
Collaboration diagram for vtkWidgetEventTranslator:
[legend]

## Public Member Functions
void | ClearEvents ()
| Clear all events from the translator (i.e., no events will be translated). More...
void | SetTranslation (unsigned long VTKEvent, unsigned long widgetEvent)
| Use these methods to create the translation from a VTK event to a widget event. More...
void | SetTranslation (const char *VTKEvent, const char *widgetEvent)
| Use these methods to create the translation from a VTK event to a widget event. More...
void | SetTranslation (unsigned long VTKEvent, int modifier, char keyCode, int repeatCount, const char *keySym, unsigned long widgetEvent)
| Use these methods to create the translation from a VTK event to a widget event. More...
void | SetTranslation (vtkEvent *VTKevent, unsigned long widgetEvent)
| Use these methods to create the translation from a VTK event to a widget event. More...
void | SetTranslation (unsigned long VTKEvent, vtkEventData *edata, unsigned long widgetEvent)
| Use these methods to create the translation from a VTK event to a widget event. More...
unsigned long | GetTranslation (unsigned long VTKEvent)
| Translate a VTK event into a widget event. More...
const char * | GetTranslation (const char *VTKEvent)
| Translate a VTK event into a widget event. More...
unsigned long | GetTranslation (unsigned long VTKEvent, int modifier, char keyCode, int repeatCount, const char *keySym)
| Translate a VTK event into a widget event. More...
unsigned long | GetTranslation (unsigned long VTKEvent, vtkEventData *edata)
| Translate a VTK event into a widget event. More...
unsigned long | GetTranslation (vtkEvent *VTKEvent)
| Translate a VTK event into a widget event. More...
int | RemoveTranslation (unsigned long VTKEvent, int modifier, char keyCode, int repeatCount, const char *keySym)
| Remove translations for a binding. More...
int | RemoveTranslation (vtkEvent *e)
| Remove translations for a binding. More...
int | RemoveTranslation (vtkEventData *e)
| Remove translations for a binding. More...
int | RemoveTranslation (unsigned long VTKEvent)
| Remove translations for a binding. More...
int | RemoveTranslation (const char *VTKEvent)
| Remove translations for a binding. More...
void | AddEventsToParent (vtkAbstractWidget *, vtkCallbackCommand *, float priority)
| Add the events in the current translation table to the interactor. More...
void | AddEventsToInteractor (vtkRenderWindowInteractor *, vtkCallbackCommand *, float priority)
| Add the events in the current translation table to the interactor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkWidgetEventTranslator * | New ()
| Instantiate the object. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkWidgetEventTranslator ()
| ~vtkWidgetEventTranslator () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkEventMap * | EventMap
vtkEvent * | Event
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkObject | Superclass
| Standard macros. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard macros. More...
static vtkWidgetEventTranslator * | SafeDownCast (vtkObjectBase *o)
| Standard macros. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard macros. More...
vtkWidgetEventTranslator * | NewInstance () const
| Standard macros. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard macros. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard macros. More...

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

map VTK events into widget events

vtkWidgetEventTranslator maps VTK events (defined on vtkCommand) into widget events (defined in vtkWidgetEvent.h). This class is typically used in combination with vtkWidgetCallbackMapper, which is responsible for translating widget events into method callbacks, and then invoking the callbacks.

This class can be used to define different mappings of VTK events into the widget events. Thus widgets can be reconfigured to use different event bindings.

See also
  vtkWidgetEvent vtkCommand vtkInteractorObserver

Tests:
  vtkWidgetEventTranslator (Tests)

Definition at line 40 of file vtkWidgetEventTranslator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkWidgetEventTranslator::Superclass

Standard macros.

Definition at line 52 of file vtkWidgetEventTranslator.h.

## Constructor & Destructor Documentation

## ◆ vtkWidgetEventTranslator()

vtkWidgetEventTranslator::vtkWidgetEventTranslator | ( |  | ) |
| protected

## ◆ ~vtkWidgetEventTranslator()

vtkWidgetEventTranslator::~vtkWidgetEventTranslator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkWidgetEventTranslator* vtkWidgetEventTranslator::New | ( |  | ) |
| static

Instantiate the object.

## ◆ IsTypeOf()

static vtkTypeBool vtkWidgetEventTranslator::IsTypeOf | ( | const char * | type | ) |
| static

Standard macros.

## ◆ IsA()

virtual vtkTypeBool vtkWidgetEventTranslator::IsA | ( | const char * | type | ) |
| virtual

Standard macros.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkWidgetEventTranslator* vtkWidgetEventTranslator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard macros.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkWidgetEventTranslator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard macros.

## ◆ NewInstance()

vtkWidgetEventTranslator* vtkWidgetEventTranslator::NewInstance | ( |  | ) | const

Standard macros.

## ◆ PrintSelf()

void vtkWidgetEventTranslator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard macros.

Reimplemented from vtkObject.

## ◆ SetTranslation() [1/5]

void vtkWidgetEventTranslator::SetTranslation | ( | unsigned long | VTKEvent,
|  | unsigned long | widgetEvent
| ) |  |

Use these methods to create the translation from a VTK event to a widget event.

Specifying vtkWidgetEvent::NoEvent or an empty string for the (toEvent) erases the mapping for the event.

## ◆ SetTranslation() [2/5]

void vtkWidgetEventTranslator::SetTranslation | ( | const char * | VTKEvent,
|  | const char * | widgetEvent
| ) |  |

Use these methods to create the translation from a VTK event to a widget event.

Specifying vtkWidgetEvent::NoEvent or an empty string for the (toEvent) erases the mapping for the event.

## ◆ SetTranslation() [3/5]

void vtkWidgetEventTranslator::SetTranslation | ( | unsigned long | VTKEvent,
|  | int | modifier,
|  | char | keyCode,
|  | int | repeatCount,
|  | const char * | keySym,
|  | unsigned long | widgetEvent
| ) |  |

Use these methods to create the translation from a VTK event to a widget event.

Specifying vtkWidgetEvent::NoEvent or an empty string for the (toEvent) erases the mapping for the event.

## ◆ SetTranslation() [4/5]

void vtkWidgetEventTranslator::SetTranslation | ( | vtkEvent * | VTKevent,
|  | unsigned long | widgetEvent
| ) |  |

Use these methods to create the translation from a VTK event to a widget event.

Specifying vtkWidgetEvent::NoEvent or an empty string for the (toEvent) erases the mapping for the event.

## ◆ SetTranslation() [5/5]

void vtkWidgetEventTranslator::SetTranslation | ( | unsigned long | VTKEvent,
|  | vtkEventData * | edata,
|  | unsigned long | widgetEvent
| ) |  |

Use these methods to create the translation from a VTK event to a widget event.

Specifying vtkWidgetEvent::NoEvent or an empty string for the (toEvent) erases the mapping for the event.

## ◆ GetTranslation() [1/5]

unsigned long vtkWidgetEventTranslator::GetTranslation | ( | unsigned long | VTKEvent | ) |

Translate a VTK event into a widget event.

If no event mapping is found, then the methods return vtkWidgetEvent::NoEvent or a nullptr string.

## ◆ GetTranslation() [2/5]

const char* vtkWidgetEventTranslator::GetTranslation | ( | const char * | VTKEvent | ) |

Translate a VTK event into a widget event.

If no event mapping is found, then the methods return vtkWidgetEvent::NoEvent or a nullptr string.

## ◆ GetTranslation() [3/5]

unsigned long vtkWidgetEventTranslator::GetTranslation | ( | unsigned long | VTKEvent,
|  | int | modifier,
|  | char | keyCode,
|  | int | repeatCount,
|  | const char * | keySym
| ) |  |

Translate a VTK event into a widget event.

If no event mapping is found, then the methods return vtkWidgetEvent::NoEvent or a nullptr string.

## ◆ GetTranslation() [4/5]

unsigned long vtkWidgetEventTranslator::GetTranslation | ( | unsigned long | VTKEvent,
|  | vtkEventData * | edata
| ) |  |

Translate a VTK event into a widget event.

If no event mapping is found, then the methods return vtkWidgetEvent::NoEvent or a nullptr string.

## ◆ GetTranslation() [5/5]

unsigned long vtkWidgetEventTranslator::GetTranslation | ( | vtkEvent * | VTKEvent | ) |

Translate a VTK event into a widget event.

If no event mapping is found, then the methods return vtkWidgetEvent::NoEvent or a nullptr string.

## ◆ RemoveTranslation() [1/5]

int vtkWidgetEventTranslator::RemoveTranslation | ( | unsigned long | VTKEvent,
|  | int | modifier,
|  | char | keyCode,
|  | int | repeatCount,
|  | const char * | keySym
| ) |  |

Remove translations for a binding.

Returns the number of translations removed.

## ◆ RemoveTranslation() [2/5]

int vtkWidgetEventTranslator::RemoveTranslation | ( | vtkEvent * | e | ) |

Remove translations for a binding.

Returns the number of translations removed.

## ◆ RemoveTranslation() [3/5]

int vtkWidgetEventTranslator::RemoveTranslation | ( | vtkEventData * | e | ) |

Remove translations for a binding.

Returns the number of translations removed.

## ◆ RemoveTranslation() [4/5]

int vtkWidgetEventTranslator::RemoveTranslation | ( | unsigned long | VTKEvent | ) |

Remove translations for a binding.

Returns the number of translations removed.

## ◆ RemoveTranslation() [5/5]

int vtkWidgetEventTranslator::RemoveTranslation | ( | const char * | VTKEvent | ) |

Remove translations for a binding.

Returns the number of translations removed.

## ◆ ClearEvents()

void vtkWidgetEventTranslator::ClearEvents | ( |  | ) |

Clear all events from the translator (i.e., no events will be translated).

## ◆ AddEventsToParent()

void vtkWidgetEventTranslator::AddEventsToParent | ( | vtkAbstractWidget * | ,
|  | vtkCallbackCommand * | ,
|  | float | priority
| ) |  |

Add the events in the current translation table to the interactor.

## ◆ AddEventsToInteractor()

void vtkWidgetEventTranslator::AddEventsToInteractor | ( | vtkRenderWindowInteractor * | ,
|  | vtkCallbackCommand * | ,
|  | float | priority
| ) |  |

Add the events in the current translation table to the interactor.

## Member Data Documentation

## ◆ EventMap

vtkEventMap* vtkWidgetEventTranslator::EventMap
| protected

Definition at line 116 of file vtkWidgetEventTranslator.h.

## ◆ Event

vtkEvent* vtkWidgetEventTranslator::Event
| protected

Definition at line 119 of file vtkWidgetEventTranslator.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkWidgetEventTranslator.h